From 3ef4367aa3513a11a96dca58f8f45658921112f8 Mon Sep 17 00:00:00 2001
From: Sarper Akdemir <sarper.akdemir@collabora.com>
Date: Mon, 15 Aug 2022 21:35:52 +0300
Subject: [PATCH] tdf#144092 pptx import: fix import of empty cell and shape
 text properties

For table cells and shapes without any text, text properties weren't
correctly imported. Both the master styles and properties defined in
the endParaRPr were ignored.

It appears the current implementation does attempt to import those in
TextParagraph::insertAt(...), after the attempt they end up in the
TextRange('s nodes) but they are ignored.

This commit implements a fix by: If the cell or shape has no text, the
text properties are also pushed into the shape or cell's propset
directly

Change-Id: Ie425b3e9a73937a2503e47322e25f37ed9a2a6be
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/138651
Tested-by: Jenkins
Reviewed-by: Miklos Vajna <vmiklos@collabora.com>
(cherry picked from commit 57f9b4b7d1ad164c56af12009ef1dafbc1be8369)
Reviewed-on: https://gerrit.libreoffice.org/c/core/+/139179
Tested-by: Jenkins CollaboraOffice <jenkinscollaboraoffice@gmail.com>
Reviewed-by: Sarper Akdemir <sarper.akdemir@collabora.com>
---
 oox/source/drawingml/shape.cxx           |  11 +++
 oox/source/drawingml/table/tablecell.cxx |  19 ++++-
 sd/qa/unit/data/xml/n762695_0.xml        |   6 +-
 sd/qa/unit/data/xml/n762695_1.xml        |  10 +--
 sd/qa/unit/data/xml/n819614_0.xml        |   2 +-
 sd/qa/unit/data/xml/n820786_0.xml        | 102 +++++++++++------------
 sd/qa/unit/data/xml/tdf109317_0.xml      |  12 +--
 7 files changed, 95 insertions(+), 67 deletions(-)

diff --git a/oox/source/drawingml/shape.cxx b/oox/source/drawingml/shape.cxx
index e76d2386c800..426f82381ba6 100644
--- a/oox/source/drawingml/shape.cxx
+++ b/oox/source/drawingml/shape.cxx
@@ -1655,6 +1655,17 @@ Reference< XShape > const & Shape::createAndInsert(
                             aPropertySet.setAnyProperty(PROP_ParaAdjust, uno::makeAny(eAdjust));
                         }
                     }
+
+                    // tdf#144092 For empty textboxes push character styles &
+                    // endParaRPr into the Shape's properties
+                    if (rParagraphs.size() == 1 && pParagraph->getRuns().empty())
+                    {
+                        TextCharacterProperties aTextCharacterProps{ pParagraph->getCharacterStyle(
+                            aCharStyleProperties, *mpMasterTextListStyle,
+                            getTextBody()->getTextListStyle()) };
+                        aTextCharacterProps.assignUsed(pParagraph->getEndProperties());
+                        aTextCharacterProps.pushToPropSet(aPropertySet, rFilterBase);
+                    }
                 }
             }
         }
diff --git a/oox/source/drawingml/table/tablecell.cxx b/oox/source/drawingml/table/tablecell.cxx
index fdf7950dcf2c..19347db21539 100644
--- a/oox/source/drawingml/table/tablecell.cxx
+++ b/oox/source/drawingml/table/tablecell.cxx
@@ -22,6 +22,8 @@
 #include <basegfx/color/bcolor.hxx>
 #include <oox/drawingml/shapepropertymap.hxx>
 #include <drawingml/textbody.hxx>
+#include <drawingml/textcharacterproperties.hxx>
+#include <drawingml/textparagraph.hxx>
 #include <oox/drawingml/theme.hxx>
 #include <oox/core/xmlfilterbase.hxx>
 #include <oox/helper/propertyset.hxx>
@@ -541,7 +543,8 @@ void TableCell::pushToXCell( const ::oox::core::XmlFilterBase& rFilterBase, cons

     // TODO: phClr?
     aFillProperties.pushToPropMap( aPropMap, rFilterBase.getGraphicHelper() );
-    PropertySet( xPropSet ).setProperties( aPropMap );
+    PropertySet aPropSet{xPropSet};
+    aPropSet.setProperties( aPropMap );

     if ( getVertToken() == XML_eaVert )
     {
@@ -550,6 +553,20 @@ void TableCell::pushToXCell( const ::oox::core::XmlFilterBase& rFilterBase, cons

     getTextBody()->insertAt( rFilterBase, xText, xAt, aTextStyleProps, pMasterTextListStyle );

+    // tdf#144092 For empty cells push character styles & endParaRPr to the Cell's properties
+    const TextParagraphVector& rParagraphs = getTextBody()->getParagraphs();
+    if (rParagraphs.size() == 1)
+    {
+        const auto pFirstParagraph = rParagraphs.at(0);
+        if (pFirstParagraph->getRuns().empty())
+        {
+            TextCharacterProperties aTextCharacterProps{ pFirstParagraph->getCharacterStyle(
+                aTextStyleProps, *pMasterTextListStyle, getTextBody()->getTextListStyle()) };
+            aTextCharacterProps.assignUsed(pFirstParagraph->getEndProperties());
+            aTextCharacterProps.pushToPropSet(aPropSet, rFilterBase);
+        }
+    }
+
     if (getVertToken() == XML_vert)
         xPropSet->setPropertyValue("RotateAngle", Any(short(27000)));
     else if (getVertToken() == XML_vert270)
